Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34921)
@@ -4633,17 +9062,91 @@
         },
     },
-    0x2000023 => {
-        Name => 'PictureControlData',
-        Binary => 1,
-        SubDirectory => { TagTable => 'Image::ExifTool::Nikon::PictureControl' },
-    },
+    0x200001f => {
+        Name => 'VRInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Nikon::VRInfo' },
+    },
+    0x2000022 => {
+        Name => 'ActiveD-Lighting',
+        Writable => 'int16u',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Low',
+            3 => 'Normal',
+            5 => 'High',
+            7 => 'Extra High',
+            8 => 'Extra High 1',
+            9 => 'Extra High 2',
+            10 => 'Extra High 3',
+            11 => 'Extra High 4',
+            0xffff => 'Auto',
+        },
+    },
+    0x2000023 => [
+        { #PH (D300, but also found in D3,D3S,D3X,D90,D300S,D700,D3000,D5000)
+            Name => 'PictureControlData',
+            Condition => '$$valPt =~ /^01/',
+            Writable => 'undef',
+            Permanent => 0,
+            Flags => [ 'Binary', 'Protected' ],
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::PictureControl' },
+        },{ #28
+            Name => 'PictureControlData',
+            Condition => '$$valPt =~ /^02/',
+            Writable => 'undef',
+            Permanent => 0,
+            Flags => [ 'Binary', 'Protected' ],
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::PictureControl2' },
+        },{
+            Name => 'PictureControlData',
+            Condition => '$$valPt =~ /^03/',
+            Writable => 'undef',
+            Permanent => 0,
+            Flags => [ 'Binary', 'Protected' ],
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::PictureControl3' },
+        },{
+            Name => 'PictureControlData',
+            Writable => 'undef',
+            Permanent => 0,
+            Flags => [ 'Binary', 'Protected' ],
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::PictureControlUnknown' },
+        },
+    ],
     0x2000024 => {
         Name => 'WorldTime',
         SubDirectory => { TagTable => 'Image::ExifTool::Nikon::WorldTime' },
     },
-    0x2000032 => {
+    0x2000025 => { #34
+        Name => 'ISOInfo',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Nikon::ISOInfo',
+            ByteOrder => 'BigEndian', # (BigEndian even for D810, which is a little-endian camera)
+        },
+    },
+    0x200002a => { #23 (this tag added with D3 firmware 1.10 -- also written by Nikon utilities)
+        Name => 'VignetteControl',
+        Writable => 'int16u',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Low',
+            3 => 'Normal',
+            5 => 'High',
+        },
+    },
+    0x200002c => {
         Name => 'UnknownInfo',
         SubDirectory => { TagTable => 'Image::ExifTool::Nikon::UnknownInfo' },
     },
+    # 0x200002d - int16u[3]: "512 0 0"
+    0x2000032 => {
+        Name => 'UnknownInfo2',
+        SubDirectory => { TagTable => 'Image::ExifTool::Nikon::UnknownInfo2' },
+    },
+    0x2000039 => {
+        Name => 'LocationInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Nikon::LocationInfo' },
+    },
+    # 0x200003f - rational64s[2]: "0 0"
+    # 0x2000042 - undef[6]: "0100\x03\0"
+    # 0x2000043 - undef[12]: all zeros
     0x2000083 => {
         Name => 'LensType',
@@ -4655,7 +9158,14 @@
                 2 => 'G',
                 3 => 'VR',
+                4 => '1', #PH
+                # bit 5 set for FT-1 adapter? - PH
+                6 => 'E', #PH (electromagnetic aperture mechanism)
+                # bit 7 set for AF-P lenses? - PH
             }) : 'AF';
             # remove commas and change "D G" to just "G"
-            s/,//g; s/\bD G\b/G/; $_
+            s/,//g; s/\bD G\b/G/;
+            s/ E\b// and s/^(G )?/E /;  # put "E" at the start instead of "G"
+            s/ 1// and $_ = "1 $_";     # put "1" at start
+            return $_;
         ],
     },
@@ -4665,4 +9175,166 @@
         PrintConv => \&Image::ExifTool::Exif::PrintLensInfo,
     },
+    0x2000087 => {
+        Name => 'FlashMode',
+        Writable => 'int8u',
+        PrintConv => {
+            0 => 'Did Not Fire',
+            1 => 'Fired, Manual', #14
+            3 => 'Not Ready', #28
+            7 => 'Fired, External', #14
+            8 => 'Fired, Commander Mode',
+            9 => 'Fired, TTL Mode',
+            18 => 'LED Light', #G.F. (movie LED light)
+        },
+    },
+    0x2000098 => [
+        { #8
+            Condition => '$$valPt =~ /^0100/', # D100, D1X - PH
+            Name => 'LensData0100',
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::LensData00' },
+        },
+        { #8
+            Condition => '$$valPt =~ /^0101/', # D70, D70s - PH
+            Name => 'LensData0101',
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::LensData01' },
+        },
+        # note: this information is encrypted if the version is 02xx
+        { #8
+            # 0201 - D200, D2Hs, D2X and D2Xs
+            # 0202 - D40, D40X and D80
+            # 0203 - D300
+            Condition => '$$valPt =~ /^020[1-3]/',
+            Name => 'LensData0201',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::LensData01',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 4,
+            },
+        },
+        { #PH
+            Condition => '$$valPt =~ /^0204/', # D90, D7000
+            Name => 'LensData0204',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::LensData0204',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 4,
+            },
+        },
+        {
+            Condition => '$$valPt =~ /^040[01]/', # 0=1J1/1V1, 1=1J2
+            Name => 'LensData0400',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::LensData0400',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 4,
+            },
+        },
+        {
+            Condition => '$$valPt =~ /^0402/', # 1J3/1S1/1V2
+            Name => 'LensData0402',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::LensData0402',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 4,
+            },
+        },
+        {
+            Condition => '$$valPt =~ /^0403/', # 1J4,1J5
+            Name => 'LensData0403',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::LensData0403',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 4,
+            },
+        },
+        {
+            Condition => '$$valPt =~ /^080[01]/', # Z6/Z7
+            Name => 'LensData0800',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::LensData0800',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 4,
+                ByteOrder => 'LittleEndian',
+                # 0x5a0c - NikonMeteringMode for some Z6 ver1.00 samples (ref PH)
+            },
+        },
+        {
+            Name => 'LensDataUnknown',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::LensDataUnknown',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 4,
+            },
+        },
+    ],
+    0x20000a7 => { # Number of shots taken by camera so far (ref 2)
+        Name => 'ShutterCount',
+        PrintConv => '$val == 4294965247 ? "n/a" : $val',
+    },
+    0x20000a8 => [
+        {
+            Name => 'FlashInfo0100',
+            Condition => '$$valPt =~ /^010[01]/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::FlashInfo0100' },
+        },
+        {
+            Name => 'FlashInfo0102',
+            Condition => '$$valPt =~ /^0102/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::FlashInfo0102' },
+        },
+        {
+            Name => 'FlashInfo0103',
+            # (0104 for D7000, 0105 for D800)
+            Condition => '$$valPt =~ /^010[345]/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::FlashInfo0103' },
+        },
+        {
+            Name => 'FlashInfo0106', # (0106 for D7100)
+            Condition => '$$valPt =~ /^0106/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::FlashInfo0106' },
+        },
+        {
+            Name => 'FlashInfo0107', # (0107 for D4S/D750/D810/D5500/D7200, 0108 for D5/D500/D3400)
+            Condition => '$$valPt =~ /^010[78]/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::FlashInfo0107' },
+        },
+        {
+            Name => 'FlashInfoUnknown',
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::FlashInfoUnknown' },
+        },
+    ],
+    0x20000ab => { Name => 'VariProgram', Writable => 'string' }, #2 (scene mode for DSLR's - PH)
+    0x20000b1 => { #34
+        Name => 'HighISONoiseReduction',
+        Writable => 'int16u',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Minimal', # for high ISO (>800) when setting is "Off"
+            2 => 'Low',     # Low,Normal,High take effect for ISO > 400
+            3 => 'Medium Low',
+            4 => 'Normal',
+            5 => 'Medium High',
+            6 => 'High',
+        },
+    },
+    0x20000b7 => {
+        Name => 'AFInfo2',
+        SubDirectory => { TagTable => 'Image::ExifTool::Nikon::AFInfo2' },
+    },
+    # 0x20000c0 - undef[8]
+    0x20000c3 => {
+        Name => 'BarometerInfo',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Nikon::BarometerInfo',
+            # (little-endian in II EXIF, big-endian in MOV)
+        },
+    },
 );
 
@@ -4671,5 +9343,4 @@
     GROUPS => { 2 => 'Camera' },
     LensSpec => {
-        Description => 'Lens',
         Require => {
             0 => 'Nikon:Lens',
@@ -4692,5 +9363,5 @@
         },
         # construct lens ID string as per ref 11
-        ValueConv => 'uc(join(" ",(unpack("H*",pack("C*",@raw)) =~ /../g)))',
+        ValueConv => 'sprintf("%.2X"." %.2X"x7, @raw)',
         PrintConv => \%nikonLensIDs,
     },
@@ -4714,9 +9385,9 @@
 sub ProcessNikonAVI($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $pos = $$dirInfo{DirStart} || 0;
     my $dirEnd = $pos + $$dirInfo{DirLen};
-    $exifTool->VerboseDir($dirInfo, undef, $$dirInfo{DirLen});
+    $et->VerboseDir($dirInfo, undef, $$dirInfo{DirLen});
     SetByteOrder('II');
     while ($pos + 4 <= $dirEnd) {
@@ -4725,5 +9396,5 @@
         $pos += 4;
         last if $pos + $size > $dirEnd;
-        $exifTool->HandleTag($tagTablePtr, $tag, undef,
+        $et->HandleTag($tagTablePtr, $tag, undef,
             DataPt => $dataPt,
             Start  => $pos,
@@ -4734,40 +9405,138 @@
     return 1;
 }
+
 #------------------------------------------------------------------------------
-# Print D3/D300 AF points (similar to Canon::PrintAFPoints1D)
-# Inputs: 0) value to convert (undef[7])
-# Focus point pattern:
-#        A1  A2  A3  A4  A5  A6  A7  A8  A9
-#    B1  B2  B3  B4  B5  B6  B7  B8  B9  B10  B11
-#    C1  C2  C3  C4  C5  C6  C7  C8  C9  C10  C11
-#    D1  D2  D3  D4  D5  D6  D7  D8  D9  D10  D11
-#        E1  E2  E3  E4  E5  E6  E7  E8  E9
-sub PrintAFPointsD3($)
+# Print conversion for Nikon AF points
+# Inputs: 0) value to convert (as a string of hex bytes),
+#         1) lookup for AF point bit number (starting at 1)
+sub PrintAFPoints($$)
 {
-    my $val = shift;
-    return 'Unknown' unless length $val == 7;
-    # list of byte/bit positions for each focus point (upper/lower nibble)
-    my @focusPts = (
-             0x55,0x50,0x43,0x14,0x02,0x07,0x21,0x26,0x33,
-        0x61,0x54,0x47,0x42,0x13,0x01,0x06,0x20,0x25,0x32,0x37,
-        0x60,0x53,0x46,0x41,0x12,0x00,0x05,0x17,0x24,0x31,0x36,
-        0x62,0x56,0x51,0x44,0x15,0x03,0x10,0x22,0x27,0x34,0x40,
-             0x57,0x52,0x45,0x16,0x04,0x11,0x23,0x30,0x35
-    );
-    my ($focusPt, @points);
-    my @dat = unpack('C*', $val);
-    my @cols = (9,11,11,11,9);
-    my $cols = shift @cols;
-    my ($row, $col) = ('A', 1);
-    foreach $focusPt (@focusPts) {
-        push @points, $row . $col if $dat[$focusPt >> 4] & (0x01 << ($focusPt & 0x0f));
-        if (++$col > $cols) {
-            $cols = shift @cols;
-            $col = 1;
-            ++$row;
+    my ($val, $afPoints) = @_;
+    my ($i, $j, @points);
+    $val =~ tr/ //d;    # remove spaces from hex string
+    my @dat = unpack 'C*', pack 'H*', $val; # convert to array of bytes
+    # loop through all bytes to find active AF points
+    for ($i=0; $i<=@dat; ++$i) {
+        next unless $dat[$i];
+        for ($j=0; $j<8; ++$j) {
+            next unless $dat[$i] & (1 << $j);
+            my $point = $$afPoints{$i*8 + $j + 1};
+            push @points, $point if defined $point;
         }
     }
     return '(none)' unless @points;
-    return join(',',@points);
+    # sort the points and return as comma-separated string
+    return join ',', sort {
+        return $a cmp $b if length($a) == length($b);
+        return substr($a,0,1).'0'.substr($a,1,1) cmp $b if length($a) == 2;
+        return $a cmp substr($b,0,1).'0'.substr($b,1,1);
+    } @points;
+}
+
+#------------------------------------------------------------------------------
+# Inverse print conversion for AF points
+# Inputs: 0) AF point string, 1) AF point lookup
+# Returns: AF point data as a string of hex bytes
+sub PrintAFPointsInv($$)
+{
+    my ($val, $afPoints) = @_;
+    my @points = ($val =~ /[A-Za-z]\d+/g);
+    my $size = int((scalar(keys %$afPoints) + 7) / 8);
+    my @dat = (0) x $size;
+    if (@points) {
+        my (%bitNum, $point);
+        $bitNum{$$afPoints{$_}} = $_ foreach keys %$afPoints; # build reverse lookup
+        foreach $point (@points) {
+            my $bitNum = $bitNum{uc $point} or next;
+            my $byte = int(($bitNum - 1) / 8);
+            $dat[$byte] |= (1 << (($bitNum - 1) % 8));
+        }
+    }
+    return join(" ", unpack("H2"x$size, pack('C*', @dat)));
+}
+
+#------------------------------------------------------------------------------
+# Get AF point name for grid-type AF
+# Inputs: 0) AF point number, 1) number of columns, 2) true for inverse conversion
+# Returns: AF point name, or undef
+sub GetAFPointGrid($$;$)
+{
+    my ($val, $ncol, $inv) = @_;
+    if ($inv) {
+        return undef unless $val =~ /^([A-J])(\d+)$/i;
+        return (ord(uc($1))-65) * $ncol + $2 - 1;
+    } else {
+        my $row = int(($val + 0.5) / $ncol);
+        my $col = $val - $ncol * $row + 1;
+        return chr(65+$row) . $col;
+    }
+}
+
+#------------------------------------------------------------------------------
+# Print conversion for grid-type AF points
+# Inputs: 0) value to convert (as a string of hex bytes),
+#         1) number of columns in grid
+sub PrintAFPointsGrid($$)
+{
+    my ($val, $ncol) = @_;
+    my ($i, $j, @points);
+    $val =~ tr/ //d;    # remove spaces from hex string
+    my @dat = unpack 'C*', pack 'H*', $val; # convert to array of bytes
+    # loop through all bytes to find active AF points
+    for ($i=0; $i<@dat; ++$i) {
+        next unless $dat[$i];
+        for ($j=0; $j<8; ++$j) {
+            next unless $dat[$i] & (1 << $j);
+            my $point = GetAFPointGrid($i*8 + $j, $ncol);
+            push @points, $point if defined $point;
+        }
+    }
+    return '(none)' unless @points;
+    return join ',', @points;   # return as comma-separated string
+}
+
+#------------------------------------------------------------------------------
+# Inverse print conversion for AF points
+# Inputs: 0) AF point string, 1) number of columns, 2) size of data
+# Returns: AF point data as a string of hex bytes
+sub PrintAFPointsGridInv($$$)
+{
+    my ($val, $ncol, $size) = @_;
+    my @points = ($val =~ /[A-Za-z]\d+/g);
+    my @dat = (0) x $size;
+    foreach (@points) {
+        my $n = GetAFPointGrid($_, $ncol, 1);
+        next unless defined $n;
+        my $byte = int($n / 8);
+        next if $byte > $size;
+        $dat[$byte] |= (1 << ($n - $byte * 8));
+    }
+    return join(" ", unpack("H2"x$size, pack('C*', @dat)));
+}
+
+#------------------------------------------------------------------------------
+# Print conversion for relative Left/Right AF points (ref 28)
+# Inputs: 0) column, 1) number of columns
+# Returns: AF point data as a string (e.g. '2L' or 'C' or '3R')
+sub PrintAFPointsLeftRight($$)
+{
+    my ($col, $ncol) = @_;
+    my $center = 1 + ($ncol + 1)/2;
+    return 'C' if $col == $center;
+    return sprintf('%d', $center - $col) . 'L of Center' if $col < $center;
+    return sprintf('%d', $col - $center) . 'R of Center' if $col > $center;
+}
+
+#------------------------------------------------------------------------------
+# Print conversion for relative Up/Down AF points (ref 28)
+# Inputs: 0) column, 1) number of columns
+# Returns: AF point data as a string (e.g. '2U' or 'C' or '3D')
+sub PrintAFPointsUpDown($$)
+{
+    my ($row, $nrow) = @_;
+    my $center = 1 + ($nrow + 1)/2;
+    return 'C' if $row == $center;
+    return sprintf('%d', $center - $row) . 'U from Center' if $row < $center;
+    return sprintf('%d', $row - $center) . 'D from Center' if $row > $center;
 }
 
@@ -4776,9 +9545,9 @@
 # Inputs: 0) value (with 0x80 subtracted),
 #         1) 'Normal' (0 value) string (default 'Normal')
-#         2) format string for numbers (default '%+d')
+#         2) format string for numbers (default '%+d'), 3) v2 divisor
 # Returns: PrintConv value
-sub PrintPC($;$$)
+sub PrintPC($;$$$)
 {
-    my ($val, $norm, $fmt) = @_;
+    my ($val, $norm, $fmt, $div) = @_;
     return $norm || 'Normal' if $val == 0;
     return 'n/a'             if $val == 0x7f;
@@ -4786,16 +9555,16 @@
     # -127 = custom curve created in Camera Control Pro (show as "User" by D3) - ref 28
     return 'User'            if $val == -127; #28
-    return sprintf($fmt || '%+d', $val);
+    return sprintf($fmt || '%+d', $val / ($div || 1));
 }
 
 #------------------------------------------------------------------------------
 # Inverse of PrintPC
-# Inputs: 0) PrintConv value (after subracting 0x80 from raw value)
+# Inputs: 0) PrintConv value (after subracting 0x80 from raw value), 1) v2 divisor
 # Returns: unconverted value
 # Notes: raw values: 0=Auto, 1=User, 0xff=n/a, ... 0x7f=-1, 0x80=0, 0x81=1, ...
-sub PrintPCInv($)
+sub PrintPCInv($;$)
 {
-    my $val = shift;
-    return $val if $val =~ /^[-+]?\d+$/;
+    my ($val, $div) = @_;
+    return $val * ($div || 1) if $val =~ /^[-+]?\d+(\.\d+)?$/;
     return 0x7f if $val =~ /n\/a/i;
     return -128 if $val =~ /auto/i;
@@ -4825,9 +9594,25 @@
         return join(' or ', @vals);
     }
-    my $regex = $val;
-    # Sigma has been changing the LensID on some new lenses
-    $regex =~ s/^\w+/../;
-    my @ids = sort grep /^$regex$/, keys %$conv;
-    return "Unknown ($val) $$conv{$ids[0]} ?" if @ids;
+    # Sigma has been changing the LensIDNumber on some new lenses
+    # and with some Sigma lenses the LensFStops changes! (argh!)
+    # Also, older cameras my not set bits 4-7 of LensType
+    my $pat = $val;
+    $pat =~ s/^\w+ \w+/.. ../;  # ignore LensIDNumber and LensFStops
+    $pat =~ s/\w(\w)$/.$1/;     # ignore bits 4-7 of LensType
+    my @ids = sort grep /^$pat$/, keys %$conv;
+    if (@ids) {
+        # first try different LensFStops (2nd value)
+        ($pat = $val) =~ s/ \w+/ ../;
+        my @good = grep /^$pat$/, @ids;
+        return $$conv{$good[0]} if @good;
+        # then try different LensIDNumber (1st value)
+        ($pat = $val) =~ s/^\w+/../;
+        @good = grep /^$pat$/, @ids;
+        return "Unknown ($val) $$conv{$good[0]} ?" if @good;
+        # older cameras may not set bits 4-7 of LensType
+        ($pat = $val) =~ s/\w(\w)$/.$1/;
+        @good = grep /^$pat$/, @ids;
+        return "Unknown ($val) $$conv{$good[0]} ?" if @good;
+    }
     return undef;
 }
@@ -4854,5 +9639,5 @@
                 # patch for a number of models that write improper string
                 # terminator for ImageStabilization (VR-OFF, VR-ON)
-                $str =~ s/  +.$//
+                $str =~ s/  +.$//s;
             }
             if ($str =~ s/\b([A-Z])([A-Z]*[AEIOUY][A-Z]*)/$1\L$2/g) {
@@ -4901,5 +9686,5 @@
 );
 
-# decrypt Nikon data block (ref 4)
+# Decrypt Nikon data block (ref 4)
 # Inputs: 0) reference to data block, 1) serial number key, 2) shutter count key
 #         4) optional start offset (default 0)
@@ -4912,5 +9697,6 @@
 
     $start or $start = 0;
-    $len = length($$dataPt) - $start if not defined $len or $len > length($$dataPt) - $start;
+    my $maxLen = length($$dataPt) - $start;
+    $len = $maxLen if not defined $len or $len > $maxLen;
     return $$dataPt if $len <= 0;
     my $key = 0;
@@ -4939,8 +9725,8 @@
 sub SerialKey($$)
 {
-    my ($exifTool, $serial) = @_;
+    my ($et, $serial) = @_;
     # use serial number as key if integral
     return $serial if not defined $serial or $serial =~ /^\d+$/;
-    return 0x22 if $$exifTool{Model} =~ /\bD50$/; # D50 (ref 8)
+    return 0x22 if $$et{Model} =~ /\bD50$/; # D50 (ref 8)
     return 0x60; # D200 (ref 10), D40X (ref PH), etc
 }
@@ -4952,34 +9738,48 @@
 sub ProcessNikonMOV($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dataPos = $$dirInfo{DataPos};
-    my $pos = $$dirInfo{DirStart};
-    my $end = $pos + $$dirInfo{DirLen};
-    $exifTool->VerboseDir($$dirInfo{DirName}, 0, $$dirInfo{DirLen});
-    while ($pos + 8 < $end) {
-        my $tag = Get32u($dataPt, $pos);
-        my $fmt = Get16u($dataPt, $pos + 4); # (same format code as EXIF)
-        my $count = Get16u($dataPt, $pos + 6);
-        $pos += 8;
-        my $fmtStr = $Image::ExifTool::Exif::formatName[$fmt];
-        unless ($fmtStr) {
-            $exifTool->Warn(sprintf("Unknown format ($fmt) for $$dirInfo{DirName} tag 0x%x",$tag));
-            last;
+    my %needTags = ( 0x110a431 => 0, 0x20000a7 => undef );  # needed for decryption
+    $et->VerboseDir($$dirInfo{DirName}, 0, $$dirInfo{DirLen});
+    my $pass;
+    # do two passes so we can pre-scan for necessary decryption keys
+    for ($pass=0; $pass<2; ++$pass) {
+        my $pos = $$dirInfo{DirStart};
+        my $end = $pos + $$dirInfo{DirLen};
+        while ($pos + 8 < $end) {
+            my $tag = Get32u($dataPt, $pos);
+            my $fmt = Get16u($dataPt, $pos + 4); # (same format code as EXIF)
+            my $count = Get16u($dataPt, $pos + 6);
+            $pos += 8;
+            my $fmtStr = $Image::ExifTool::Exif::formatName[$fmt];
+            unless ($fmtStr) {
+                $et->Warn(sprintf("Unknown format ($fmt) for $$dirInfo{DirName} tag 0x%x",$tag)) if $pass;
+                last;
+            }
+            my $size = $count * $Image::ExifTool::Exif::formatSize[$fmt];
+            if ($pos + $size > $end) {
+                $et->Warn(sprintf("Truncated data for $$dirInfo{DirName} tag 0x%x",$tag)) if $pass;
+                last;
+            }
+            if ($pass) {
+                my $rational;
+                my $val = ReadValue($dataPt, $pos, $fmtStr, $count, $size, \$rational);
+                my $key = $et->HandleTag($tagTablePtr, $tag, $val,
+                    DataPt  => $dataPt,
+                    DataPos => $dataPos,
+                    Format  => $fmtStr,
+                    Start   => $pos,
+                    Size    => $size,
+                    Base    => $$dirInfo{Base},
+                );
+                $$et{RATIONAL}{$key} = $rational if $rational and $key;
+            } elsif (exists $needTags{$tag}) {
+                $needTags{$tag} = ReadValue($dataPt, $pos, $fmtStr, $count, $size);
+                $$et{NikonSerialKey} = SerialKey($et, $needTags{0x110a431});
+                $$et{NikonCountKey} = $needTags{0x20000a7};
+            }
+            $pos += $size;  # is this padded to an even offset????
         }
-        my $size = $count * $Image::ExifTool::Exif::formatSize[$fmt];
-        if ($pos + $size > $end) {
-            $exifTool->Warn(sprintf("Truncated data for $$dirInfo{DirName} tag 0x%x",$tag));
-            last;
-        }
-        my $val = ReadValue($dataPt, $pos, $fmtStr, $count, $size);
-        $exifTool->HandleTag($tagTablePtr, $tag, $val,
-            DataPt  => $dataPt,
-            DataPos => $dataPos,
-            Format  => $fmtStr,
-            Start   => $pos,
-            Size    => $size,
-        );
-        $pos += $size;  # is this padded to an even offset????
     }
     return 1;
@@ -4992,46 +9792,53 @@
 sub ProcessNikonEncrypted($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    $exifTool or return 1;    # allow dummy access
-    my $serial = $$exifTool{NikonSerialKey};
-    my $count = $$exifTool{NikonCountKey};
-    unless (defined $serial and defined $count) {
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;    # allow dummy access
+    my $serial = $$et{NikonSerialKey};
+    my $count = $$et{NikonCountKey};
+    unless (defined $serial and defined $count and $serial =~ /^\d+$/ and $count =~ /^\d+$/) {
         if (defined $serial or defined $count) {
-            my $missing = defined $serial ? 'ShutterCount' : 'SerialNumber';
-            $exifTool->Warn("Can't decrypt Nikon information (no $missing key)");
+            my $msg;
+            if (defined $serial and defined $count) {
+                $msg = $serial =~ /^\d+$/ ? 'invalid ShutterCount' : 'invalid SerialNumber';
+            } else {
+                $msg = defined $serial ? 'no ShutterCount' : 'no SerialNumber';
+            }
+            $et->Warn("Can't decrypt Nikon information ($msg key)");
         }
-        delete $$exifTool{NikonSerialKey};
-        delete $$exifTool{NikonCountKey};
+        delete $$et{NikonSerialKey};
+        delete $$et{NikonCountKey};
         return 0;
     }
-    my $verbose = $$dirInfo{IsWriting} ? 0 : $exifTool->Options('Verbose');
+    my $verbose = $$dirInfo{IsWriting} ? 0 : $et->Options('Verbose');
     my $tagInfo = $$dirInfo{TagInfo};
-    my $data = substr(${$$dirInfo{DataPt}}, $$dirInfo{DirStart}, $$dirInfo{DirLen});
-
-    my ($start, $len, $offset, $byteOrder, $recrypt, $newSerial, $newCount);
+    my $dirStart = $$dirInfo{DirStart};
+    my $data = substr(${$$dirInfo{DataPt}}, $dirStart, $$dirInfo{DirLen});
+
+    my ($start, $len, $more, $offset, $byteOrder, $recrypt, $newSerial, $newCount);
 
     # must re-encrypt when writing if serial number or shutter count changes
     if ($$dirInfo{IsWriting}) {
-        if ($$exifTool{NewNikonSerialKey}) {
-            $newSerial = $$exifTool{NewNikonSerialKey};
+        if ($$et{NewNikonSerialKey}) {
+            $newSerial = $$et{NewNikonSerialKey};
             $recrypt = 1;
         }
-        if ($$exifTool{NewNikonCountKey}) {
-            $newCount = $$exifTool{NewNikonCountKey};
+        if ($$et{NewNikonCountKey}) {
+            $newCount = $$et{NewNikonCountKey};
             $recrypt = 1;
         }
     }
     if ($tagInfo and $$tagInfo{SubDirectory}) {
-        $start = $tagInfo->{SubDirectory}->{DecryptStart};
+        $start = $$tagInfo{SubDirectory}{DecryptStart};
         # may decrypt only part of the information to save time
-        if ($verbose < 3 and $exifTool->Options('Unknown') < 2 and not $recrypt) {
-            $len = $tagInfo->{SubDirectory}->{DecryptLen};
+        if ($verbose < 3 and $et->Options('Unknown') < 2 and not $recrypt) {
+            $len = $$tagInfo{SubDirectory}{DecryptLen};
+            $more = $$tagInfo{SubDirectory}{DecryptMore};
         }
-        $offset = $tagInfo->{SubDirectory}->{DirOffset};
-        $byteOrder = $tagInfo->{SubDirectory}->{ByteOrder};
+        $offset = $$tagInfo{SubDirectory}{DirOffset};
+        $byteOrder = $$tagInfo{SubDirectory}{ByteOrder};
     }
     $start or $start = 0;
     if (defined $offset) {
-        # offset, if specified, is releative to start of encrypted data
+        # offset, if specified, is relative to start of encrypted data
         $offset += $start;
     } else {
@@ -5040,13 +9847,32 @@
     my $maxLen = length($data) - $start;
     # decrypt all the data unless DecryptLen is given
-    $len = $maxLen unless $len and $len <= $maxLen;
+    unless ($len and $len < $maxLen) {
+        $len = $maxLen;
+        undef $more;    # (can't decrypt more than this)
+    }
 
     $data = Decrypt(\$data, $serial, $count, $start, $len);
 
+    # set appropriate byte ordering before evaluating DecryptMore
+    my $oldOrder = GetByteOrder();
+    SetByteOrder($byteOrder) if $byteOrder;
+
+    if ($more) {
+        #### eval DecryptMore ($data)
+        my $moreLen = eval $more;
+        $moreLen = $maxLen if $moreLen > $maxLen;
+        # re-decrypt with new length
+        if ($len < $moreLen) {
+            $len = $moreLen;
+            $data = substr(${$$dirInfo{DataPt}}, $dirStart, $$dirInfo{DirLen});
+            $data = Decrypt(\$data, $serial, $count, $start, $len);
+        }
+    }
     if ($verbose > 2) {
-        $exifTool->VerboseDir("Decrypted $$tagInfo{Name}");
-        $exifTool->VerboseDump(\$data,
-            Prefix  => $exifTool->{INDENT} . '  ',
-            DataPos => $$dirInfo{DirStart} + $$dirInfo{DataPos} + ($$dirInfo{Base} || 0),
+        $et->VerboseDir("Decrypted $$tagInfo{Name}");
+        $et->VerboseDump(\$data,
+            Prefix  => $$et{INDENT} . '  ',
+            # (remove this because it is useful to have decrypted offsets start at 0)
+            #DataPos => $dirStart + $$dirInfo{DataPos} + ($$dirInfo{Base} || 0),
         );
     }
